#include <wiringPi.h>
#include <stdio.h>
#include <stdlib.h>

// 定义 PWM 引脚的 WiringPi 编号
#define PWM_PIN_SPEED 21
#define PWM_PIN_CHANGE 2

// 定义 PWM 频率为 50Hz
#define PWM_FREQ 50
// 定义占空比范围，这里设置为 0 到 1000
#define MAX_DUTY 1000

const int gpioWPi[] = {5, 6, 7, 10, 16, 20, 22, 23, 24, 25, 26, 27};

void pin_init()//初始化引脚
{
    int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
    // 设置所有GPIO为输出模式
    for(int i = 0; i < gpioCount; i++) {
        pinMode(gpioWPi[i], OUTPUT);
        digitalWrite(gpioWPi[i], LOW);  // 初始化所有引脚为低电平
    }
    
}

void pin_all_default()//全部至低电平
{
	int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
	for (int i=0;i<gpioCount;i++)
	{
		digitalWrite(gpioWPi[i], LOW);
	}
}

void pin_value(int pin,int value)
{
	if(value==1)
	{
		digitalWrite(pin, HIGH);
	}
	else if(value==0)
	{
		digitalWrite(pin, LOW);
	}
	printf("pin:%d,%d\n",pin,value);
}

void pwm_speed() {

    int pwm_clock = 24000000 / (PWM_FREQ * 1000);
    pinMode(PWM_PIN_SPEED,PWM_OUTPUT);
    pinMode(PWM_PIN_CHANGE,PWM_OUTPUT);

    pwmSetClock(PWM_PIN_SPEED,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_SPEED,MAX_DUTY);
    pwmSetClock(PWM_PIN_CHANGE,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_CHANGE,MAX_DUTY);

	pwmWrite(PWM_PIN_SPEED,75);
    pwmWrite(PWM_PIN_CHANGE,70);
    
}

void midde_pwm()
{
    pwmWrite(PWM_PIN_SPEED,75);
    pwmWrite(PWM_PIN_CHANGE,70);
}

void mode_1_flont(unsigned char gval)
{

    if(gval<50)
	{
		pwmWrite(PWM_PIN_SPEED,75);
	}
	if(50<=gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,74);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,73);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,73);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,72);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,72);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,71);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,70);
        
	}
}

void mode_2_back(unsigned char gval)
{

   if(gval<50)
	{
		pwmWrite(PWM_PIN_SPEED,75);
	}
	if(50<=gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,76);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,76);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,77);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,77);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,78);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,78);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,79);
        
	}
}

void mode_3_left(unsigned char gval)
{
    if(gval<45)
	{
	pwmWrite(PWM_PIN_CHANGE,70);
	}
	if(gval>=45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,80);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,83);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,85);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,90);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,95);
	}
}

void mode_4_right(unsigned char gval)
{
    if(gval<45)
	{
		pwmWrite(PWM_PIN_CHANGE,70);
	}
	if(gval>=45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,60);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,57);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,54);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,50);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,45);
	}
}

void speed_change(unsigned char *buf)//速度和转向引脚数值处理函数
{
    unsigned char mode=buf[1];
    unsigned char val=buf[2];

    switch(mode)
    {
        case 1:			
		mode_1_flont(val);					 
			break;
		case 2:	
			mode_2_back(val);
			break;
		case 3:
			mode_3_left(val);
			break;
		case 4:
			mode_4_right(val);
			break; 
        default:
			break;
    }
    
}
